//AB/ Project Maintenance View
//AB/ Object prj is a VIEW_Project
//AB/     Set ProjectName to "Maintenance View"
//AB/     Set ProjectFileName to "Cdtypent.vw"

// Project Object Structure
//   Types_Maint is a dbView
//     Codetype_DD is a DataDictionary
//     Codemast_DD is a DataDictionary
//     CodeTypeGroup is a dbGroup
//       Codetype_Type is a dbForm
//       Codetype_Description is a dbForm
//       Codetype_Comment is a dbEdit
//     CodeMastGroup is a dbGroup
//       CodeMastGrid is a dbGrid

// Register all objects
Register_Object CodeMastGrid
Register_Object CodeMastGroup
Register_Object Codemast_DD
Register_Object CodeTypeGroup
Register_Object Codetype_Comment
Register_Object Codetype_DD
Register_Object Codetype_Description
Register_Object Codetype_Type
Register_Object Types_Maint


//AB/ AppBuild VIEW

//AB-IgnoreStart

Use DFAllEnt.pkg

Use CODETYPE.DD
Use CODEMAST.DD

//AB-IgnoreEnd

ACTIVATE_VIEW Activate_Types_Maint FOR Types_Maint

Object Types_Maint is a dbView

    //AB-StoreTopStart
    
    //AB-StoreTopEnd

    Set Label to "Maintain Code Files"
    Set Size to 209 287

    //AB-DDOStart

    Object Codetype_DD is a CodeType_DataDictionary
    End_Object    // Codetype_DD

    Object Codemast_DD is a Codemast_DataDictionary
        Set DDO_Server to (Codetype_DD(Current_Object))
        Set Constrain_File to Codetype.File_Number
    End_Object    // Codemast_DD

    Set Main_DD to (Codetype_DD(Current_Object))
    Set Server to (Codetype_DD(Current_Object))

    //AB-DDOEnd

    Object CodeTypeGroup is a dbGroup
        Set Label to "Code Types:"
        Set Size to 83 270
        Set Location to 4 6
        Object Codetype_Type is a dbForm
            Entry_Item Codetype.Type
            Set Label to "Type:"
            Set Label_Col_Offset to 50
            Set Size to 13 60
            Set Location to 8 60
        End_Object    // Codetype_Type

        Object Codetype_Description is a dbForm
            Entry_Item Codetype.Description
            Set Label to "Description:"
            Set Label_Col_Offset to 50
            Set Size to 13 188
            Set Location to 23 60
        End_Object    // Codetype_Description

        Object Codetype_Comment is a dbEdit
            Entry_Item Codetype.Comment
            Set Label to "Comment:"
            Set Size to 32 252
            Set Location to 46 10
        End_Object    // Codetype_Comment


        //AB-StoreStart
        // Return non-zero if table entry should not be allowed.
        //
        // Rules:
        // 1. if no data, disallow movement
        // 2. if new ask
        // 3. if old just save it
        //
        Function Allow_Child_Entry Returns Integer
            Local Integer Obj# Srvr# SaveMsg
            Get Server to Srvr#
            // new unchanged record...don't allow
            If (Should_Save(Current_Object)=0 AND Current_record(Srvr#)=0) Begin
                Error 300 'You must enter a TYPE code first.'
                Function_Return 1
            End
            // save if needed
            If (Current_record(Srvr#) OR confirm(self,"Save New Type Information?")=0) Begin
                Get Verify_Save_MSG to SaveMsg             // the old confirmation
                Set Verify_Save_MSG to GET_No_Confirmation // disable confirmation
                Send Request_Save_no_Clear                 // save it
                Set Verify_Save_MSG to SaveMsg             // restore old confirm
            End
            // If save is still required, don't allow exit.
            Function_Return (Should_Save(Current_Object))
        End_Function  // Allow_Child_Entry
        //AB-StoreEnd

    End_Object    // CodeTypeGroup

    Object CodeMastGroup is a dbGroup
        Set Label to "Code Master File:"
        Set Size to 97 270
        Set Location to 90 6
        Object CodeMastGrid is a dbGrid
            Set Server to (Codemast_DD(Current_Object))
            Set Ordering to 1
            Set Wrap_State to TRUE
            Set Size to 83 257
            Set Location to 10 7

            Begin_Row
                Entry_Item Codemast.Code
                Entry_Item Codemast.Description
            End_Row

            Set Form_Width    item 0 to 60
            Set Header_Label  item 0 to "Code"
            
            Set Form_Width    item 1 to 190
            Set Header_Label  item 1 to "Description"
            

            //AB-StoreStart
            Set Child_Table_State to TRUE  // force save on exit
            // we must ask the parent if it is ok to enter this
            //
            Function Child_Entering Returns Integer
                Local Integer rVal
                //
                Get Allow_Child_Entry of (CodeTypeGroup(Current_Object)) to rVal
                Function_Return rVal
            End_Function  // Child_Entering
            //AB-StoreEnd

        End_Object    // CodeMastGrid

    End_Object    // CodeMastGroup


    //AB-StoreStart
    
    //AB-StoreEnd

End_Object    // Types_Maint

//AB/ End_Object    // prj
